diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/tx-duration-test.cc ns-3.43/src/wifi/test/tx-duration-test.cc
--- ns-3.42/src/wifi/test/tx-duration-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/tx-duration-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Nicola Baldo <nbaldo@cttc.es>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -57,8 +46,8 @@
      *
      * @param size size of payload in octets (includes everything after the PHY header)
      * @param payloadMode the WifiMode used for the transmission
-     * @param channelWidth the channel width used for the transmission (in MHz)
-     * @param guardInterval the guard interval duration used for the transmission (in nanoseconds)
+     * @param channelWidth the channel width used for the transmission
+     * @param guardInterval the guard interval duration used for the transmission
      * @param preamble the WifiPreamble used for the transmission
      * @param knownDuration the known duration value of the transmission
      *
@@ -66,8 +55,8 @@
      */
     bool CheckPayloadDuration(uint32_t size,
                               WifiMode payloadMode,
-                              uint16_t channelWidth,
-                              uint16_t guardInterval,
+                              MHz_u channelWidth,
+                              Time guardInterval,
                               WifiPreamble preamble,
                               Time knownDuration);
 
@@ -77,8 +66,8 @@
      *
      * @param size size of payload in octets (includes everything after the PHY header)
      * @param payloadMode the WifiMode used for the transmission
-     * @param channelWidth the channel width used for the transmission (in MHz)
-     * @param guardInterval the guard interval duration used for the transmission (in nanoseconds)
+     * @param channelWidth the channel width used for the transmission
+     * @param guardInterval the guard interval duration used for the transmission
      * @param preamble the WifiPreamble used for the transmission
      * @param knownDuration the known duration value of the transmission
      *
@@ -86,8 +75,8 @@
      */
     bool CheckTxDuration(uint32_t size,
                          WifiMode payloadMode,
-                         uint16_t channelWidth,
-                         uint16_t guardInterval,
+                         MHz_u channelWidth,
+                         Time guardInterval,
                          WifiPreamble preamble,
                          Time knownDuration);
 
@@ -97,8 +86,8 @@
      *
      * @param sizes the list of PSDU sizes for each station in octets
      * @param userInfos the list of HE MU specific user transmission parameters
-     * @param channelWidth the channel width used for the transmission (in MHz)
-     * @param guardInterval the guard interval duration used for the transmission (in nanoseconds)
+     * @param channelWidth the channel width used for the transmission
+     * @param guardInterval the guard interval duration used for the transmission
      * @param preamble the WifiPreamble used for the transmission
      * @param knownDuration the known duration value of the transmission
      *
@@ -106,8 +95,8 @@
      */
     static bool CheckMuTxDuration(std::list<uint32_t> sizes,
                                   std::list<HeMuUserInfo> userInfos,
-                                  uint16_t channelWidth,
-                                  uint16_t guardInterval,
+                                  MHz_u channelWidth,
+                                  Time guardInterval,
                                   WifiPreamble preamble,
                                   Time knownDuration);
 
@@ -143,8 +132,8 @@
 bool
 TxDurationTest::CheckPayloadDuration(uint32_t size,
                                      WifiMode payloadMode,
-                                     uint16_t channelWidth,
-                                     uint16_t guardInterval,
+                                     MHz_u channelWidth,
+                                     Time guardInterval,
                                      WifiPreamble preamble,
                                      Time knownDuration)
 {
@@ -195,8 +184,8 @@
 bool
 TxDurationTest::CheckTxDuration(uint32_t size,
                                 WifiMode payloadMode,
-                                uint16_t channelWidth,
-                                uint16_t guardInterval,
+                                MHz_u channelWidth,
+                                Time guardInterval,
                                 WifiPreamble preamble,
                                 Time knownDuration)
 {
@@ -254,8 +243,8 @@
 bool
 TxDurationTest::CheckMuTxDuration(std::list<uint32_t> sizes,
                                   std::list<HeMuUserInfo> userInfos,
-                                  uint16_t channelWidth,
-                                  uint16_t guardInterval,
+                                  MHz_u channelWidth,
+                                  Time guardInterval,
                                   WifiPreamble preamble,
                                   Time knownDuration)
 {
@@ -265,7 +254,7 @@
                            std::begin(userInfos),
                            std::end(userInfos),
                            0,
-                           [](const uint16_t prevBw, const HeMuUserInfo& info) {
+                           [](const MHz_u prevBw, const HeMuUserInfo& info) {
                                return prevBw + HeRu::GetBandwidth(info.ru.GetRuType());
                            }),
         "Cannot accommodate all the RUs in the provided band"); // MU-MIMO (for which allocations
@@ -369,25 +358,25 @@
              CheckPayloadDuration(1023,
                                   DsssPhy::GetDsssRate11Mbps(),
                                   22,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_LONG,
                                   MicroSeconds(744)) &&
              CheckPayloadDuration(1024,
                                   DsssPhy::GetDsssRate11Mbps(),
                                   22,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_LONG,
                                   MicroSeconds(745)) &&
              CheckPayloadDuration(1025,
                                   DsssPhy::GetDsssRate11Mbps(),
                                   22,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_LONG,
                                   MicroSeconds(746)) &&
              CheckPayloadDuration(1026,
                                   DsssPhy::GetDsssRate11Mbps(),
                                   22,
-                                  800,
+                                  NanoSeconds(800),
                                   WIFI_PREAMBLE_LONG,
                                   MicroSeconds(747));
 
@@ -401,193 +390,193 @@
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(744 + 96)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(745 + 96)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(746 + 96)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(747 + 96)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(744 + 192)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(745 + 192)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(746 + 192)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(747 + 192)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(1488 + 96)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(1490 + 96)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(1491 + 96)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(1493 + 96)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(1488 + 192)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(1490 + 192)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(1491 + 192)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate5_5Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(1493 + 192)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(4092 + 96)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(4096 + 96)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(4100 + 96)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(4104 + 96)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(4092 + 192)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(4096 + 192)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(4100 + 192)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate2Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(4104 + 192)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(8184 + 192)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(8192 + 192)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(8200 + 192)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_SHORT,
                              MicroSeconds(8208 + 192)) &&
              CheckTxDuration(1023,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(8184 + 192)) &&
              CheckTxDuration(1024,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(8192 + 192)) &&
              CheckTxDuration(1025,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(8200 + 192)) &&
              CheckTxDuration(1026,
                              DsssPhy::GetDsssRate1Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(8208 + 192));
 
@@ -596,7 +585,7 @@
     retval = retval && CheckTxDuration(14,
                                        DsssPhy::GetDsssRate1Mbps(),
                                        22,
-                                       800,
+                                       NanoSeconds(800),
                                        WIFI_PREAMBLE_LONG,
                                        MicroSeconds(304));
 
@@ -605,19 +594,19 @@
              CheckTxDuration(1536,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(1310)) &&
              CheckTxDuration(76,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(248)) &&
              CheckTxDuration(14,
                              DsssPhy::GetDsssRate11Mbps(),
                              22,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(203));
 
@@ -629,19 +618,19 @@
              CheckTxDuration(1536,
                              OfdmPhy::GetOfdmRate54Mbps(),
                              20,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(248)) &&
              CheckTxDuration(76,
                              OfdmPhy::GetOfdmRate54Mbps(),
                              20,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(32)) &&
              CheckTxDuration(14,
                              OfdmPhy::GetOfdmRate54Mbps(),
                              20,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(24));
 
@@ -652,67 +641,116 @@
              CheckTxDuration(1536,
                              ErpOfdmPhy::GetErpOfdmRate54Mbps(),
                              20,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(254)) &&
              CheckTxDuration(76,
                              ErpOfdmPhy::GetErpOfdmRate54Mbps(),
                              20,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(38)) &&
              CheckTxDuration(14,
                              ErpOfdmPhy::GetErpOfdmRate54Mbps(),
                              20,
-                             800,
+                             NanoSeconds(800),
                              WIFI_PREAMBLE_LONG,
                              MicroSeconds(30));
 
     NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11g duration failed");
 
     // 802.11n durations
-    retval =
-        retval &&
-        CheckTxDuration(1536,
-                        HtPhy::GetHtMcs7(),
-                        20,
-                        800,
-                        WIFI_PREAMBLE_HT_MF,
-                        MicroSeconds(228)) &&
-        CheckTxDuration(76, HtPhy::GetHtMcs7(), 20, 800, WIFI_PREAMBLE_HT_MF, MicroSeconds(48)) &&
-        CheckTxDuration(14, HtPhy::GetHtMcs7(), 20, 800, WIFI_PREAMBLE_HT_MF, MicroSeconds(40)) &&
-        CheckTxDuration(1536,
-                        HtPhy::GetHtMcs0(),
-                        20,
-                        400,
-                        WIFI_PREAMBLE_HT_MF,
-                        NanoSeconds(1742400)) &&
-        CheckTxDuration(76, HtPhy::GetHtMcs0(), 20, 400, WIFI_PREAMBLE_HT_MF, MicroSeconds(126)) &&
-        CheckTxDuration(14, HtPhy::GetHtMcs0(), 20, 400, WIFI_PREAMBLE_HT_MF, NanoSeconds(57600)) &&
-        CheckTxDuration(1536,
-                        HtPhy::GetHtMcs6(),
-                        20,
-                        400,
-                        WIFI_PREAMBLE_HT_MF,
-                        NanoSeconds(226800)) &&
-        CheckTxDuration(76, HtPhy::GetHtMcs6(), 20, 400, WIFI_PREAMBLE_HT_MF, NanoSeconds(46800)) &&
-        CheckTxDuration(14, HtPhy::GetHtMcs6(), 20, 400, WIFI_PREAMBLE_HT_MF, NanoSeconds(39600)) &&
-        CheckTxDuration(1536,
-                        HtPhy::GetHtMcs7(),
-                        40,
-                        800,
-                        WIFI_PREAMBLE_HT_MF,
-                        MicroSeconds(128)) &&
-        CheckTxDuration(76, HtPhy::GetHtMcs7(), 40, 800, WIFI_PREAMBLE_HT_MF, MicroSeconds(44)) &&
-        CheckTxDuration(14, HtPhy::GetHtMcs7(), 40, 800, WIFI_PREAMBLE_HT_MF, MicroSeconds(40)) &&
-        CheckTxDuration(1536,
-                        HtPhy::GetHtMcs7(),
-                        40,
-                        400,
-                        WIFI_PREAMBLE_HT_MF,
-                        NanoSeconds(118800)) &&
-        CheckTxDuration(76, HtPhy::GetHtMcs7(), 40, 400, WIFI_PREAMBLE_HT_MF, NanoSeconds(43200)) &&
-        CheckTxDuration(14, HtPhy::GetHtMcs7(), 40, 400, WIFI_PREAMBLE_HT_MF, NanoSeconds(39600));
+    retval = retval &&
+             CheckTxDuration(1536,
+                             HtPhy::GetHtMcs7(),
+                             20,
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(228)) &&
+             CheckTxDuration(76,
+                             HtPhy::GetHtMcs7(),
+                             20,
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(48)) &&
+             CheckTxDuration(14,
+                             HtPhy::GetHtMcs7(),
+                             20,
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(40)) &&
+             CheckTxDuration(1536,
+                             HtPhy::GetHtMcs0(),
+                             20,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(1742400)) &&
+             CheckTxDuration(76,
+                             HtPhy::GetHtMcs0(),
+                             20,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(126)) &&
+             CheckTxDuration(14,
+                             HtPhy::GetHtMcs0(),
+                             20,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(57600)) &&
+             CheckTxDuration(1536,
+                             HtPhy::GetHtMcs6(),
+                             20,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(226800)) &&
+             CheckTxDuration(76,
+                             HtPhy::GetHtMcs6(),
+                             20,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(46800)) &&
+             CheckTxDuration(14,
+                             HtPhy::GetHtMcs6(),
+                             20,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(39600)) &&
+             CheckTxDuration(1536,
+                             HtPhy::GetHtMcs7(),
+                             40,
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(128)) &&
+             CheckTxDuration(76,
+                             HtPhy::GetHtMcs7(),
+                             40,
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(44)) &&
+             CheckTxDuration(14,
+                             HtPhy::GetHtMcs7(),
+                             40,
+                             NanoSeconds(800),
+                             WIFI_PREAMBLE_HT_MF,
+                             MicroSeconds(40)) &&
+             CheckTxDuration(1536,
+                             HtPhy::GetHtMcs7(),
+                             40,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(118800)) &&
+             CheckTxDuration(76,
+                             HtPhy::GetHtMcs7(),
+                             40,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(43200)) &&
+             CheckTxDuration(14,
+                             HtPhy::GetHtMcs7(),
+                             40,
+                             NanoSeconds(400),
+                             WIFI_PREAMBLE_HT_MF,
+                             NanoSeconds(39600));
 
     NS_TEST_EXPECT_MSG_EQ(retval, true, "an 802.11n duration failed");
 
